import _defineProperty from '@babel/runtime/helpers/defineProperty';
import _extends from '@babel/runtime/helpers/extends';
import _toConsumableArray from '@babel/runtime/helpers/toConsumableArray';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import React, { Component, useEffect } from 'react';
import { injectIntl, useIntl } from 'react-intl';
import { connect, useSelector, useDispatch } from 'react-redux';
import { Tune, LocalHospital, HealingOutlined, LocalPharmacyOutlined, Healing, LocalPharmacy, Person, AccountBalance, PinDrop, LocationCity, Delete, Tab, Edit } from '@material-ui/icons';
import { withModulesManager, formatMessage, MainMenuContribution, ProxyPage, decodeId, ControlledField, PublishedComponent, TextInput, formatPageQuery, graphql, formatPageQueryWithCount, formatMutation, formatGQLString, FormattedMessage, Searcher, formatMessageWithValues, journalize, formatDateFromISO, withHistory, historyPush, withTooltip, FormPanel, parseData, ProgressOrError, Form, coreConfirm, AutoSuggestion, dispatchMutationResp, dispatchMutationErr, dispatchMutationReq, formatServerError, formatGraphQLError, pageInfo } from '@openimis/fe-core';
import _assertThisInitialized from '@babel/runtime/helpers/assertThisInitialized';
import { Grid, Dialog, DialogTitle, DialogContent, DialogContentText, DialogActions, Button, Tooltip, IconButton, Fab } from '@material-ui/core';
import AddIcon from '@material-ui/icons/Add';
import { withTheme, withStyles } from '@material-ui/core/styles';
import { bindActionCreators } from 'redux';
import _debounce from 'lodash/debounce';
import _ from 'lodash';
import 'lodash-uuid';
import ReplayIcon from '@material-ui/icons/Replay';
import TextField from '@material-ui/core/TextField';
import Autocomplete from '@material-ui/lab/Autocomplete';
import _slicedToArray from '@babel/runtime/helpers/slicedToArray';

var RIGHT_PRODUCTS = 121001;
var RIGHT_HEALTHFACILITIES = 121101;
var RIGHT_PRICELISTMS = 121201;
var RIGHT_PRICELISTMI = 121301;
var RIGHT_MEDICALSERVICES = 121401;
var RIGHT_MEDICALITEMS = 122101;
var RIGHT_ENROLMENTOFFICER = 121501;
var RIGHT_CLAIMADMINISTRATOR = 121601;
var RIGHT_PAYERS = 121801;
var RIGHT_LOCATIONS = 121901;
var RIGHT_USERS = 121701;
var RIGHT_USER_ADD = 121702;
var RIGHT_USER_EDIT = 121703;
var RIGHT_USER_DELETE = 121704;
var USER_TYPES = function USER_TYPES(rights) {
  var baseTypes = ["INTERACTIVE"];

  if (rights.includes(RIGHT_ENROLMENTOFFICER)) {
    baseTypes.push("OFFICER");

    if (rights.includes(RIGHT_CLAIMADMINISTRATOR)) {
      baseTypes.push("CLAIM_ADMIN");
    }
  }

  return baseTypes;
};
var userTypesMapping = {
  iUser: "INTERACTIVE",
  officer: "OFFICER",
  claimAdmin: "CLAIM_ADMIN"
};

function _createSuper$h(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$h(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$h() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var ADMIN_MAIN_MENU_CONTRIBUTION_KEY = "admin.MainMenu";

var AdminMainMenu = /*#__PURE__*/function (_Component) {
  _inherits(AdminMainMenu, _Component);

  var _super = _createSuper$h(AdminMainMenu);

  function AdminMainMenu() {
    _classCallCheck(this, AdminMainMenu);

    return _super.apply(this, arguments);
  }

  _createClass(AdminMainMenu, [{
    key: "render",
    value: function render() {
      var rights = this.props.rights;
      var entries = [];

      if (rights.includes(RIGHT_PRODUCTS)) {
        entries.push({
          text: formatMessage(this.props.intl, "admin", "menu.products"),
          icon: /*#__PURE__*/React.createElement(Tune, null),
          route: "/admin/products"
        });
      }

      if (rights.includes(RIGHT_HEALTHFACILITIES)) {
        entries.push({
          text: formatMessage(this.props.intl, "admin", "menu.healthFacilities"),
          icon: /*#__PURE__*/React.createElement(LocalHospital, null),
          route: "/location/healthFacilities",
          withDivider: true
        });
      }

      if (rights.includes(RIGHT_PRICELISTMS)) {
        entries.push({
          text: formatMessage(this.props.intl, "admin", "menu.medicalServicesPrices"),
          icon: /*#__PURE__*/React.createElement(HealingOutlined, null),
          route: "/admin/medicalServicesPriceList"
        });
      }

      if (rights.includes(RIGHT_PRICELISTMI)) {
        entries.push({
          text: formatMessage(this.props.intl, "admin", "menu.medicalItemsPrices"),
          icon: /*#__PURE__*/React.createElement(LocalPharmacyOutlined, null),
          route: "/admin/medicalItemsPriceList",
          withDivider: true
        });
      }

      if (rights.includes(RIGHT_MEDICALSERVICES)) {
        entries.push({
          text: formatMessage(this.props.intl, "admin", "menu.medicalServices"),
          icon: /*#__PURE__*/React.createElement(Healing, null),
          route: "/admin/medicalServices"
        });
      }

      if (rights.includes(RIGHT_MEDICALITEMS)) {
        entries.push({
          text: formatMessage(this.props.intl, "admin", "menu.medicalItems"),
          icon: /*#__PURE__*/React.createElement(LocalPharmacy, null),
          route: "/admin/medilcalItems",
          withDivider: true
        });
      }

      if (rights.includes(RIGHT_USERS)) {
        entries.push({
          text: formatMessage(this.props.intl, "admin", "menu.users"),
          icon: /*#__PURE__*/React.createElement(Person, null),
          route: "/admin/users"
        });
      }

      if (rights.includes(RIGHT_PAYERS)) {
        entries.push({
          text: formatMessage(this.props.intl, "admin", "menu.payers"),
          icon: /*#__PURE__*/React.createElement(AccountBalance, null),
          route: "/admin/payers"
        });
      }

      if (rights.includes(RIGHT_LOCATIONS)) {
        entries.push({
          text: formatMessage(this.props.intl, "admin", "menu.locations"),
          icon: /*#__PURE__*/React.createElement(PinDrop, null),
          route: "/location/locations"
        });
      }

      entries.push.apply(entries, _toConsumableArray(this.props.modulesManager.getContribs(ADMIN_MAIN_MENU_CONTRIBUTION_KEY).filter(function (c) {
        return !c.filter || c.filter(rights);
      })));
      if (!entries.length) return null;
      return /*#__PURE__*/React.createElement(MainMenuContribution, _extends({}, this.props, {
        header: formatMessage(this.props.intl, "admin", "mainMenu"),
        icon: /*#__PURE__*/React.createElement(LocationCity, null),
        entries: entries
      }));
    }
  }]);

  return AdminMainMenu;
}(Component);

var mapStateToProps$7 = function mapStateToProps(state) {
  return {
    rights: !!state.core && !!state.core.user && !!state.core.user.i_user ? state.core.user.i_user.rights : []
  };
};

var AdminMainMenu$1 = withModulesManager(injectIntl(connect(mapStateToProps$7)(AdminMainMenu)));

function _createSuper$g(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$g(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$g() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var ProductsPage = /*#__PURE__*/function (_Component) {
  _inherits(ProductsPage, _Component);

  var _super = _createSuper$g(ProductsPage);

  function ProductsPage() {
    _classCallCheck(this, ProductsPage);

    return _super.apply(this, arguments);
  }

  _createClass(ProductsPage, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(ProxyPage, {
        url: "/FindProduct.aspx"
      });
    }
  }]);

  return ProductsPage;
}(Component);

function _createSuper$f(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$f(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$f() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var MedicalServicesPriceListPage = /*#__PURE__*/function (_Component) {
  _inherits(MedicalServicesPriceListPage, _Component);

  var _super = _createSuper$f(MedicalServicesPriceListPage);

  function MedicalServicesPriceListPage() {
    _classCallCheck(this, MedicalServicesPriceListPage);

    return _super.apply(this, arguments);
  }

  _createClass(MedicalServicesPriceListPage, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(ProxyPage, {
        url: "/FindPriceListMS.aspx"
      });
    }
  }]);

  return MedicalServicesPriceListPage;
}(Component);

function _createSuper$e(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$e(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$e() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var MedicalItemsPriceListPage = /*#__PURE__*/function (_Component) {
  _inherits(MedicalItemsPriceListPage, _Component);

  var _super = _createSuper$e(MedicalItemsPriceListPage);

  function MedicalItemsPriceListPage() {
    _classCallCheck(this, MedicalItemsPriceListPage);

    return _super.apply(this, arguments);
  }

  _createClass(MedicalItemsPriceListPage, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(ProxyPage, {
        url: "/FindPriceListMI.aspx"
      });
    }
  }]);

  return MedicalItemsPriceListPage;
}(Component);

function _createSuper$d(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$d(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$d() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var MedicalServicesPage = /*#__PURE__*/function (_Component) {
  _inherits(MedicalServicesPage, _Component);

  var _super = _createSuper$d(MedicalServicesPage);

  function MedicalServicesPage() {
    _classCallCheck(this, MedicalServicesPage);

    return _super.apply(this, arguments);
  }

  _createClass(MedicalServicesPage, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(ProxyPage, {
        url: "/FindMedicalService.aspx"
      });
    }
  }]);

  return MedicalServicesPage;
}(Component);

function _createSuper$c(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$c(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$c() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var MedicalItemsPage = /*#__PURE__*/function (_Component) {
  _inherits(MedicalItemsPage, _Component);

  var _super = _createSuper$c(MedicalItemsPage);

  function MedicalItemsPage() {
    _classCallCheck(this, MedicalItemsPage);

    return _super.apply(this, arguments);
  }

  _createClass(MedicalItemsPage, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(ProxyPage, {
        url: "/FindMedicalItem.aspx"
      });
    }
  }]);

  return MedicalItemsPage;
}(Component);

function ownKeys$3(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$3(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$3(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$3(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper$b(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$b(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$b() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var styles$6 = function styles(theme) {
  return {
    dialogTitle: theme.dialog.title,
    dialogContent: theme.dialog.content,
    form: {
      padding: "0 0 10px 0",
      width: "100%"
    },
    item: {
      padding: theme.spacing(1)
    },
    paperDivider: theme.paper.divider
  };
};

var getParentLocation = function getParentLocation(locations) {
  var locationsArray = Object.values(locations).map(function (l) {
    return l.value;
  });
  var region = locationsArray.find(function (l) {
    return !l.parent;
  });
  var district = region && locationsArray.find(function (l) {
    return l.parent && l.parent.id === region.id;
  });
  var municipality = district && locationsArray.find(function (l) {
    return l.parent && l.parent.id === district.id;
  });
  var village = municipality && locationsArray.find(function (l) {
    return l.parent && l.parent.id === municipality.id;
  });

  if (!region) {
    return null;
  }

  var newLocation = {
    key: "regionId",
    id: decodeId(region.id)
  };

  if (district) {
    newLocation = {
      key: "districtId",
      id: decodeId(district.id)
    };
  }

  if (municipality) {
    newLocation = {
      key: "municipalityId",
      id: decodeId(municipality.id)
    };
  }

  if (village) {
    newLocation = {
      key: "villageId",
      id: decodeId(village.id)
    };
  }

  return newLocation;
};

var UserFilter = /*#__PURE__*/function (_Component) {
  _inherits(UserFilter, _Component);

  var _super = _createSuper$b(UserFilter);

  function UserFilter() {
    var _this;

    _classCallCheck(this, UserFilter);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      showHistory: false,
      currentUserType: undefined,
      currentUserRoles: undefined,
      locationFilters: {}
    });

    _defineProperty(_assertThisInitialized(_this), "debouncedOnChangeFilter", _debounce(_this.props.onChangeFilters, _this.props.modulesManager.getConf("fe-admin", "debounceTime", 800)));

    _defineProperty(_assertThisInitialized(_this), "filterValue", function (k) {
      var filters = _this.props.filters;
      return !!filters && !!filters[k] ? filters[k].value : null;
    });

    _defineProperty(_assertThisInitialized(_this), "onChangeShowHistory", function () {
      var filters = [{
        id: "showHistory",
        value: !_this.state.showHistory,
        filter: "showHistory: ".concat(!_this.state.showHistory)
      }];

      _this.props.onChangeFilters(filters);

      _this.setState(function (state) {
        return {
          showHistory: !state.showHistory
        };
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onChangeUserTypes", function (currentUserType) {
      var onChangeFilters = _this.props.onChangeFilters;

      _this.setState({
        currentUserType: currentUserType
      });

      onChangeFilters([{
        id: "userTypes",
        value: currentUserType,
        filter: currentUserType ? "userTypes: [".concat(currentUserType, "]") : null
      }]);
    });

    _defineProperty(_assertThisInitialized(_this), "onChangeUserRoles", function (currentUserRoles) {
      var onChangeFilters = _this.props.onChangeFilters;

      _this.setState({
        currentUserRoles: currentUserRoles
      });

      onChangeFilters([{
        id: "roles",
        value: currentUserRoles,
        filter: currentUserRoles ? "roles: [".concat(currentUserRoles.map(function (ur) {
          return decodeId(ur.id);
        }).join(","), "]") : null
      }]);
    });

    _defineProperty(_assertThisInitialized(_this), "onChangeLocation", function (newLocationFilters) {
      var onChangeFilters = _this.props.onChangeFilters;

      var locationFilters = _objectSpread$3({}, _this.state.locationFilters);

      newLocationFilters.forEach(function (filter) {
        if (filter.value === null) {
          delete locationFilters[filter.id];
        } else {
          locationFilters[filter.id] = {
            value: filter.value,
            filter: filter.filter
          };
        }
      });

      _this.setState({
        locationFilters: locationFilters
      });

      var parentLocation = getParentLocation(locationFilters);
      var filters = [{
        id: "parentLocation",
        filter: parentLocation && "".concat(parentLocation.key, ": ").concat(parentLocation.id)
      }];
      onChangeFilters(filters);
    });

    return _this;
  }

  _createClass(UserFilter, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.filters.showHistory !== this.props.filters.showHistory && !!this.props.filters.showHistory && this.state.showHistory !== this.props.filters.showHistory.value) {
        this.setState(function (state, props) {
          return {
            showHistory: props.filters.showHistory.value
          };
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          classes = _this$props.classes,
          onChangeFilters = _this$props.onChangeFilters;
      var _this$state = this.state,
          locationFilters = _this$state.locationFilters,
          currentUserType = _this$state.currentUserType,
          currentUserRoles = _this$state.currentUserRoles;
      return /*#__PURE__*/React.createElement("section", {
        className: classes.form
      }, /*#__PURE__*/React.createElement(Grid, {
        container: true
      }, /*#__PURE__*/React.createElement(ControlledField, {
        module: "admin",
        id: "userFilter.userTypes",
        field: /*#__PURE__*/React.createElement(Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React.createElement(PublishedComponent, {
          pubRef: "admin.UserTypesPicker",
          value: currentUserType,
          onChange: function onChange(v) {
            return _this2.onChangeUserTypes(v);
          }
        }))
      }), /*#__PURE__*/React.createElement(ControlledField, {
        module: "admin",
        id: "userFilter.userRoles",
        field: /*#__PURE__*/React.createElement(Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React.createElement(PublishedComponent, {
          pubRef: "admin.UserRolesPicker",
          value: currentUserRoles,
          onChange: function onChange(v) {
            return _this2.onChangeUserRoles(v);
          }
        }))
      }), /*#__PURE__*/React.createElement(ControlledField, {
        module: "admin",
        id: "userFilter.healthFacility",
        field: /*#__PURE__*/React.createElement(Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React.createElement(PublishedComponent, {
          pubRef: "location.HealthFacilityPicker",
          withNull: true,
          value: this.filterValue("healthFacilityId") || "",
          onChange: function onChange(v) {
            onChangeFilters([{
              id: "healthFacility",
              value: v,
              filter: v ? "healthFacilityId: ".concat(decodeId(v.id)) : null
            }]);
          }
        }))
      })), /*#__PURE__*/React.createElement(Grid, {
        container: true
      }, /*#__PURE__*/React.createElement(Grid, {
        item: true,
        xs: 12
      }, /*#__PURE__*/React.createElement(PublishedComponent, {
        pubRef: "location.DetailedLocationFilter",
        withNull: true,
        filters: locationFilters,
        onChangeFilters: this.onChangeLocation,
        anchor: "parentLocation"
      }))), /*#__PURE__*/React.createElement(Grid, {
        container: true
      }, /*#__PURE__*/React.createElement(ControlledField, {
        module: "admin",
        id: "userFilter.username",
        field: /*#__PURE__*/React.createElement(Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React.createElement(TextInput, {
          module: "user",
          label: "admin.user.username",
          name: "username",
          value: this.filterValue("username"),
          onChange: function onChange(v) {
            return _this2.debouncedOnChangeFilter([{
              id: "username",
              value: v,
              filter: "username_Icontains: \"".concat(v, "\"")
            }]);
          }
        }))
      }), /*#__PURE__*/React.createElement(ControlledField, {
        module: "admin",
        id: "userFilter.LastName",
        field: /*#__PURE__*/React.createElement(Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React.createElement(TextInput, {
          module: "user",
          label: "admin.user.lastName",
          name: "lastName",
          value: this.filterValue("lastName"),
          onChange: function onChange(v) {
            return _this2.debouncedOnChangeFilter([{
              id: "lastName",
              value: v,
              filter: "lastName: \"".concat(v, "\"")
            }]);
          }
        }))
      }), /*#__PURE__*/React.createElement(ControlledField, {
        module: "admin",
        id: "userFilter.OtherNames",
        field: /*#__PURE__*/React.createElement(Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React.createElement(TextInput, {
          module: "user",
          label: "admin.user.otherNames",
          name: "otherNames",
          value: this.filterValue("otherNames"),
          onChange: function onChange(v) {
            return _this2.debouncedOnChangeFilter([{
              id: "otherNames",
              value: v,
              filter: "otherNames: \"".concat(v, "\"")
            }]);
          }
        }))
      }), /*#__PURE__*/React.createElement(ControlledField, {
        module: "admin",
        id: "userFilter.Email",
        field: /*#__PURE__*/React.createElement(Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React.createElement(TextInput, {
          module: "user",
          label: "admin.user.email",
          name: "email",
          value: this.filterValue("email"),
          onChange: function onChange(v) {
            return _this2.debouncedOnChangeFilter([{
              id: "email",
              value: v,
              filter: "email: \"".concat(v, "\"")
            }]);
          }
        }))
      })), /*#__PURE__*/React.createElement(Grid, {
        container: true
      }, /*#__PURE__*/React.createElement(ControlledField, {
        module: "admin",
        id: "userFilter.Phone",
        field: /*#__PURE__*/React.createElement(Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React.createElement(TextInput, {
          module: "user",
          label: "admin.user.phone",
          name: "phone",
          value: this.filterValue("phone"),
          onChange: function onChange(v) {
            return _this2.debouncedOnChangeFilter([{
              id: "phone",
              value: v,
              filter: "phone: \"".concat(v, "\"")
            }]);
          }
        }))
      }), /*#__PURE__*/React.createElement(ControlledField, {
        module: "admin",
        id: "UserFilter.dob",
        field: /*#__PURE__*/React.createElement(Grid, {
          item: true,
          xs: 6
        }, /*#__PURE__*/React.createElement(Grid, {
          container: true
        }, /*#__PURE__*/React.createElement(Grid, {
          item: true,
          xs: 6,
          className: classes.item
        }, /*#__PURE__*/React.createElement(PublishedComponent, {
          pubRef: "core.DatePicker",
          value: this.filterValue("dobFrom"),
          module: "user",
          label: "admin.user.dobFrom",
          onChange: function onChange(d) {
            return onChangeFilters([{
              id: "dobFrom",
              value: d,
              filter: "birthDateFrom: \"".concat(d, "\"")
            }]);
          }
        })), /*#__PURE__*/React.createElement(Grid, {
          item: true,
          xs: 6,
          className: classes.item
        }, /*#__PURE__*/React.createElement(PublishedComponent, {
          pubRef: "core.DatePicker",
          value: this.filterValue("dobTo"),
          module: "user",
          label: "admin.user.dobTo",
          onChange: function onChange(d) {
            return onChangeFilters([{
              id: "dobTo",
              value: d,
              filter: "birthDateTo: \"".concat(d, "\"")
            }]);
          }
        }))))
      })));
    }
  }]);

  return UserFilter;
}(Component);

var UserFilter$1 = withModulesManager(injectIntl(withTheme(withStyles(styles$6)(UserFilter))));

var USER_SUMMARY_PROJECTION = ["id", "username", "officer{id,dob,phone,lastName,otherNames,email}", "iUser{id,phone,lastName,otherNames,email,roles{id,name}}", "claimAdmin{id,phone,lastName,otherNames,emailId,dob}", "clientMutationId"];

var USER_FULL_PROJECTION = function USER_FULL_PROJECTION(mm) {
  return ["id", "username", "officer{id,phone,dob,lastName,otherNames,address,substitutionOfficer{id},worksTo,location{id,name}}", "iUser{id,phone,languageId,lastName,otherNames,roles{id,name}", "healthFacility".concat(mm.getProjection("location.HealthFacilityPicker.projection")), ",validityFrom,validityTo,email,healthFacilityId,userdistrictSet{location{id,name,parent{id,name}}}}", "claimAdmin{id,emailId,phone,dob,lastName,otherNames}", "clientMutationId"];
};

function formatUserGQL(mm, user) {
  var req = "\n    ".concat(user.id ? "id: \"".concat(decodeId(user.id), "\"") : "", "\n    ").concat(user.username ? "username: \"".concat(user.username, "\"") : "", "\n    ").concat(user.lastName ? "lastName: \"".concat(formatGQLString(user.lastName), "\"") : "", "\n    ").concat(user.language ? "language: \"".concat(formatGQLString(user.language), "\"") : 'language: "en"', "\n    ").concat(user.otherNames ? "otherNames: \"".concat(formatGQLString(user.otherNames), "\"") : "", "\n    ").concat(user.phoneNumber ? "phoneNumber: \"".concat(formatGQLString(user.phoneNumber), "\"") : "", "\n    ").concat(user.birthDate ? "birthDate: \"".concat(formatGQLString(user.birthDate), "\"") : "", "\n    ").concat(user.email ? "email: \"".concat(formatGQLString(user.email), "\"") : "", "\n    ").concat(user.userTypes ? "userTypes: [".concat(user.userTypes, "]") : "", "\n    ").concat(user.password ? "password: \"".concat(formatGQLString(user.password), "\"") : "", "\n    ").concat(user.healthFacility ? "healthFacilityId: ".concat(decodeId(user.healthFacility.id)) : "", "\n    ").concat(user.roles ? "roles: [".concat(user.roles.map(function (u) {
    return decodeId(u.id);
  }), "]") : "", "\n    ").concat(user.address ? "address: \"".concat(formatGQLString(user.address), "\"") : "", "\n    ").concat(user.substitutionOfficerId ? "substitutionOfficerId: \"".concat(formatGQLString(user.substitutionOfficerId), "\"") : "", "\n    ").concat(user.worksTo ? "worksTo: \"".concat(formatGQLString(user.worksTo), "\"") : "", "\n\n  ");
  return req;
}
function fetchUsers(mm, hf, str, prev) {
  var filters = [];

  if (hf) {
    filters.push("healthFacility_Uuid: \"".concat(hf.uuid, "\""));
  }

  if (str) {
    filters.push("str: \"".concat(str, "\""));
  }

  if (_.isEqual(filters, prev)) {
    return function (dispatch) {};
  }

  var payload = formatPageQuery("users", filters, mm.getRef("admin.UserPicker.projection"));
  return graphql(payload, "ADMIN_USERS", filters);
}
function fetchUserRoles(mm, hf, str, prev) {
  var filters = [];

  if (hf) {
    filters.push("healthFacility_Uuid: \"".concat(hf.uuid, "\""));
  }

  if (str) {
    filters.push("str: \"".concat(str, "\""));
  }

  if (_.isEqual(filters, prev)) {
    return function (dispatch) {};
  }

  var payload = formatPageQuery("role", filters, mm.getRef("admin.UserRolesPicker.projection"));
  return graphql(payload, "ADMIN_USER_ROLES", filters);
}
function fetchUsersSummaries(mm, filters) {
  var payload = formatPageQueryWithCount("users", filters, USER_SUMMARY_PROJECTION);
  return graphql(payload, "ADMIN_USERS_SUMMARIES");
}
function createUser(mm, user, clientMutationLabel) {
  var mutation = formatMutation("createUser", formatUserGQL(mm, user), clientMutationLabel);
  var requestedDateTime = new Date();
  return graphql(mutation.payload, ["ADMIN_USER_MUTATION_REQ", "ADMIN_USER_CREATE_RESP", "ADMIN_USER_MUTATION_ERR"], {
    clientMutationId: mutation.clientMutationId,
    clientMutationLabel: clientMutationLabel,
    requestedDateTime: requestedDateTime
  });
}
function updateUser(mm, user, clientMutationLabel) {
  var mutation = formatMutation("updateUser", formatUserGQL(mm, user), clientMutationLabel);
  var requestedDateTime = new Date();
  return graphql(mutation.payload, ["ADMIN_USER_MUTATION_REQ", "ADMIN_USER_UPDATE_RESP", "ADMIN_USER_MUTATION_ERR"], {
    clientMutationId: mutation.clientMutationId,
    clientMutationLabel: clientMutationLabel,
    requestedDateTime: requestedDateTime,
    userId: user.id
  });
}
function deleteUser(mm, user, clientMutationLabel) {
  var mutation = formatMutation("deleteUser", "uuids: [\"".concat(decodeId(user.id), "\"]"), clientMutationLabel); // eslint-disable-next-line no-param-reassign

  user.clientMutationId = mutation.clientMutationId;
  var requestedDateTime = new Date();
  return graphql(mutation.payload, ["ADMIN_USER_MUTATION_REQ", "ADMIN_USER_DELETE_RESP", "ADMIN_USER_MUTATION_ERR"], {
    clientMutationId: mutation.clientMutationId,
    clientMutationLabel: clientMutationLabel,
    requestedDateTime: requestedDateTime,
    userId: user.id
  });
}
function fetchUser(mm, userId, clientMutationId) {
  var filters = [];

  if (userId) {
    filters.push("id: \"".concat(decodeId(userId), "\""));
  } else if (clientMutationId) {
    filters.push("clientMutationId: \"".concat(clientMutationId, "\""));
  }

  var payload = formatPageQuery("users", filters, USER_FULL_PROJECTION(mm));
  return graphql(payload, "ADMIN_USER_OVERVIEW");
}
function newUser() {
  return function (dispatch) {
    dispatch({
      type: "ADMIN_USER_NEW"
    });
  };
}
function fetchUserMutation(mm, clientMutationId) {
  var payload = formatPageQuery("mutationLogs", ["clientMutationId:\"".concat(clientMutationId, "\"")], ["id", "users{coreUser{id}}"]);
  return graphql(payload, "ADMIN_USER");
}

function _createSuper$a(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$a(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$a() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var styles$5 = function styles(theme) {
  return {
    primaryButton: theme.dialog.primaryButton,
    secondaryButton: theme.dialog.secondaryButton
  };
};

var DeleteUserDialog = /*#__PURE__*/function (_Component) {
  _inherits(DeleteUserDialog, _Component);

  var _super = _createSuper$a(DeleteUserDialog);

  function DeleteUserDialog() {
    _classCallCheck(this, DeleteUserDialog);

    return _super.apply(this, arguments);
  }

  _createClass(DeleteUserDialog, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          classes = _this$props.classes,
          user = _this$props.user,
          onCancel = _this$props.onCancel,
          onConfirm = _this$props.onConfirm;
      return /*#__PURE__*/React.createElement(Dialog, {
        open: !!user,
        onClose: onCancel
      }, /*#__PURE__*/React.createElement(DialogTitle, null, /*#__PURE__*/React.createElement(FormattedMessage, {
        module: "admin",
        id: "user.deleteDialog.title"
      })), /*#__PURE__*/React.createElement(DialogContent, null, /*#__PURE__*/React.createElement(DialogContentText, null, /*#__PURE__*/React.createElement(FormattedMessage, {
        module: "admin",
        id: "user.deleteDialog.message"
      }))), /*#__PURE__*/React.createElement(DialogActions, null, /*#__PURE__*/React.createElement(Button, {
        onClick: function onClick(e) {
          return onConfirm();
        },
        className: classes.primaryButton,
        autoFocus: true
      }, /*#__PURE__*/React.createElement(FormattedMessage, {
        module: "admin",
        id: "user.deleteDialog.yes.button"
      })), /*#__PURE__*/React.createElement(Button, {
        onClick: onCancel,
        className: classes.secondaryButton
      }, /*#__PURE__*/React.createElement(FormattedMessage, {
        module: "core",
        id: "cancel"
      }))));
    }
  }]);

  return DeleteUserDialog;
}(Component);

var DeleteUserDialog$1 = injectIntl(withTheme(withStyles(styles$5)(DeleteUserDialog)));

function _createSuper$9(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$9(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$9() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var USER_SEARCHER_CONTRIBUTION_KEY = "user.UserSearcher";

var UserSearcher = /*#__PURE__*/function (_Component) {
  _inherits(UserSearcher, _Component);

  var _super = _createSuper$9(UserSearcher);

  function UserSearcher(props) {
    var _this;

    _classCallCheck(this, UserSearcher);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "state", {
      deleteUser: null,
      reset: 0
    });

    _defineProperty(_assertThisInitialized(_this), "fetch", function (prms) {
      _this.props.fetchUsersSummaries(_this.props.modulesManager, prms);
    });

    _defineProperty(_assertThisInitialized(_this), "rowIdentifier", function (r) {
      return r.uuid;
    });

    _defineProperty(_assertThisInitialized(_this), "filtersToQueryParams", function (state) {
      var prms = Object.keys(state.filters).filter(function (contrib) {
        return !!state.filters[contrib].filter;
      }).map(function (contrib) {
        return state.filters[contrib].filter;
      });
      prms.push("first: ".concat(state.pageSize));

      if (state.afterCursor) {
        prms.push("after: \"".concat(state.afterCursor, "\""));
      }

      if (state.beforeCursor) {
        prms.push("before: \"".concat(state.beforeCursor, "\""));
      }

      if (state.orderBy) {
        prms.push("orderBy: [\"".concat(state.orderBy, "\"]"));
      }

      return prms;
    });

    _defineProperty(_assertThisInitialized(_this), "headers", function () {
      var h = ["admin.user.username", "admin.user.lastName", "admin.user.otherNames", "admin.user.email", "admin.user.phone", "admin.user.dob"];
      return h;
    });

    _defineProperty(_assertThisInitialized(_this), "sorts", function () {
      var results = [["username", true], ["iUser_LastName", true], ["iUser_OtherNames", true], ["iUser_email", true], ["iUser_Phone", true], ["officer__dob", false]];
      return results;
    });

    _defineProperty(_assertThisInitialized(_this), "deleteUser", function () {
      var user = _this.state.deleteUser;

      _this.setState({
        deleteUser: null
      }, function (e) {
        _this.props.deleteUser(_this.props.modulesManager, user, formatMessage(_this.props.intl, "admin.user", "deleteDialog.title"));
      });
    });

    _defineProperty(_assertThisInitialized(_this), "confirmDelete", function (deletedUser) {
      _this.setState({
        deleteUser: deletedUser
      });
    });

    _defineProperty(_assertThisInitialized(_this), "deleteAction", function (i) {
      return !!i.validityTo || !!i.clientMutationId ? null : /*#__PURE__*/React.createElement(Tooltip, {
        title: formatMessage(_this.props.intl, "admin.user", "deleteUser.tooltip")
      }, /*#__PURE__*/React.createElement(IconButton, {
        onClick: function onClick() {
          return _this.confirmDelete(i);
        }
      }, /*#__PURE__*/React.createElement(Delete, null)));
    });

    _defineProperty(_assertThisInitialized(_this), "getUserItem", function (user, item) {
      return user.iUser && user.iUser[item] || user.officer && user.officer[item] || user.claimAdmin && user.claimAdmin[item];
    });

    _defineProperty(_assertThisInitialized(_this), "itemFormatters", function () {
      var formatters = [function (u) {
        return u.username;
      }, function (u) {
        return _this.getUserItem(u, "lastName");
      }, function (u) {
        return _this.getUserItem(u, "otherNames");
      }, function (u) {
        return _this.getUserItem(u, "email") || _this.getUserItem(u, "emailId");
      }, function (u) {
        return _this.getUserItem(u, "phone");
      }, function (u) {
        console.log({
          u: u
        });
        return (u.claimAdmin || u.officer) && formatDateFromISO(_this.props.modulesManager, _this.props.intl, _this.getUserItem(u, "dob"));
      }, function (u) {
        return /*#__PURE__*/React.createElement(Tooltip, {
          title: formatMessage(_this.props.intl, "admin.user", "openNewTab")
        }, /*#__PURE__*/React.createElement(IconButton, {
          onClick: function onClick(e) {
            return _this.props.onDoubleClick(u, true);
          }
        }, /*#__PURE__*/React.createElement(Tab, null)));
      }];

      if (_this.props.rights.includes(RIGHT_USER_DELETE)) {
        formatters.push(_this.deleteAction);
      }

      return formatters;
    });

    _defineProperty(_assertThisInitialized(_this), "rowDisabled", function (selection, i) {
      return !!i.validityTo;
    });

    _defineProperty(_assertThisInitialized(_this), "rowLocked", function (selection, i) {
      return !!i.clientMutationId;
    });

    _this.rowsPerPageOptions = [10, 20, 50, 100];
    _this.defaultPageSize = 10;
    _this.locationLevels = 4;
    return _this;
  }

  _createClass(UserSearcher, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.submittingMutation && !this.props.submittingMutation) {
        this.props.journalize(this.props.mutation);
        this.setState({
          reset: this.state.reset + 1
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          intl = _this$props.intl,
          users = _this$props.users,
          usersPageInfo = _this$props.usersPageInfo,
          fetchingUsers = _this$props.fetchingUsers,
          fetchedUsers = _this$props.fetchedUsers,
          errorUsers = _this$props.errorUsers,
          filterPaneUsersKey = _this$props.filterPaneUsersKey,
          cacheFiltersKey = _this$props.cacheFiltersKey,
          _onDoubleClick = _this$props.onDoubleClick;
      var count = usersPageInfo.totalCount;
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(DeleteUserDialog$1, {
        user: this.state.deleteUser,
        onConfirm: this.deleteUser,
        onCancel: function onCancel(e) {
          return _this2.setState({
            deleteUser: null
          });
        }
      }), /*#__PURE__*/React.createElement(Searcher, {
        module: "user",
        cacheFiltersKey: cacheFiltersKey,
        FilterPane: UserFilter$1,
        filterPaneUsersKey: filterPaneUsersKey,
        items: users,
        itemsPageInfo: usersPageInfo,
        fetchingItems: fetchingUsers,
        fetchedItems: fetchedUsers,
        errorItems: errorUsers,
        userKey: USER_SEARCHER_CONTRIBUTION_KEY,
        tableTitle: formatMessageWithValues(intl, "admin.user", "userSummaries", {
          count: count
        }),
        rowsPerPageOptions: this.rowsPerPageOptions,
        defaultPageSize: this.defaultPageSize,
        fetch: this.fetch,
        rowIdentifier: this.rowIdentifier,
        filtersToQueryParams: this.filtersToQueryParams,
        defaultOrderBy: "-username",
        headers: this.headers,
        itemFormatters: this.itemFormatters,
        sorts: this.sorts,
        rowDisabled: this.rowDisabled,
        rowLocked: this.rowLocked,
        onDoubleClick: function onDoubleClick(c) {
          return !c.clientMutationId && _onDoubleClick(c);
        },
        reset: this.state.reset
      }));
    }
  }]);

  return UserSearcher;
}(Component);

var mapStateToProps$6 = function mapStateToProps(state) {
  return {
    rights: !!state.core && !!state.core.user && !!state.core.user.i_user ? state.core.user.i_user.rights : [],
    users: state.admin.usersSummaries,
    usersPageInfo: state.admin.usersPageInfo,
    fetchingUsers: state.admin.fetchingUsersSummaries,
    fetchedUsers: state.admin.fetchedUsersSummaries,
    errorUsers: state.admin.errorUsersSummaries,
    submittingMutation: state.admin.submittingMutation,
    mutation: state.admin.mutation
  };
};

var mapDispatchToProps$3 = function mapDispatchToProps(dispatch) {
  return bindActionCreators({
    fetchUsersSummaries: fetchUsersSummaries,
    deleteUser: deleteUser,
    journalize: journalize
  }, dispatch);
};

var UserSearcher$1 = withModulesManager(connect(mapStateToProps$6, mapDispatchToProps$3)(injectIntl(UserSearcher)));

function _createSuper$8(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$8(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$8() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var styles$4 = function styles(theme) {
  return {
    page: theme.page,
    fab: theme.fab
  };
};

var UsersPage = /*#__PURE__*/function (_Component) {
  _inherits(UsersPage, _Component);

  var _super = _createSuper$8(UsersPage);

  function UsersPage() {
    var _this;

    _classCallCheck(this, UsersPage);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "onDoubleClick", function (u) {
      var newTab = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      historyPush(_this.props.modulesManager, _this.props.history, "admin.userOverview", [u.id], newTab);
    });

    _defineProperty(_assertThisInitialized(_this), "onAdd", function () {
      historyPush(_this.props.modulesManager, _this.props.history, "admin.userNew");
    });

    return _this;
  }

  _createClass(UsersPage, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          classes = _this$props.classes,
          rights = _this$props.rights,
          intl = _this$props.intl;
      return /*#__PURE__*/React.createElement("div", {
        className: classes.page
      }, /*#__PURE__*/React.createElement(UserSearcher$1, {
        cacheFiltersKey: "usersPageFiltersCache",
        onDoubleClick: this.onDoubleClick
      }), rights.includes(RIGHT_USER_ADD) && withTooltip( /*#__PURE__*/React.createElement("div", {
        className: classes.fab
      }, /*#__PURE__*/React.createElement(Fab, {
        color: "primary",
        onClick: this.onAdd
      }, /*#__PURE__*/React.createElement(AddIcon, null))), formatMessage(intl, "admin.user", "addNewUser.tooltip")));
    }
  }]);

  return UsersPage;
}(Component);

var mapStateToProps$5 = function mapStateToProps(state) {
  return {
    rights: !!state.core && !!state.core.user && !!state.core.user.i_user ? state.core.user.i_user.rights : []
  };
};

var UsersPage$1 = injectIntl(withModulesManager(withHistory(connect(mapStateToProps$5)(withTheme(withStyles(styles$4)(UsersPage))))));

function _createSuper$7(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$7(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$7() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var getUserTypes = function getUserTypes(user) {
  var userTypes = [];

  if (user.iUser && user.iUser.id) {
    userTypes.push(userTypesMapping.iUser);
  }

  if (user.officer && user.officer.id) {
    userTypes.push(userTypesMapping.officer);
  }

  if (user.claimAdmin && user.claimAdmin.id) {
    userTypes.push(userTypesMapping.claimAdmin);
  }

  return userTypes;
};
var mapQueriesUserToMutation = function mapQueriesUserToMutation(u) {
  // TODO: make this more generic
  if (u.iUser) {
    u.lastName = u.iUser.lastName;
    u.otherNames = u.iUser.otherNames;
    u.email = u.iUser.email;
    u.phoneNumber = u.iUser.phone;
    u.healthFacility = u.iUser.healthFacility;
    u.language = u.iUser.languageId;
    u.roles = u.iUser.roles;
  }

  if (u.claimAdmin) {
    u.lastName = u.claimAdmin.lastName;
    u.otherNames = u.claimAdmin.otherNames;
    u.email = u.claimAdmin.emailId;
    u.phoneNumber = u.claimAdmin.phone;
    u.birthDate = u.claimAdmin.dob;
    u.healthFacility = u.claimAdmin.healthFacility;
  }

  if (u.officer) {
    u.lastName = u.officer.lastName;
    u.otherNames = u.officer.otherNames;
    u.email = u.officer.email;
    u.phoneNumber = u.officer.phone;
    u.birthDate = u.officer.dob;
    u.address = u.officer.address;
    u.substitutionOfficerId = u.officer.substitutionOfficer ? u.officer.substitutionOfficer.id : null;
    u.worksTo = u.officer.worksTo;
  }

  return u;
};

var styles$3 = function styles(theme) {
  return {
    tableTitle: theme.table.title,
    item: theme.paper.item,
    fullHeight: {
      height: "100%"
    }
  };
};

var UserMasterPanel = /*#__PURE__*/function (_FormPanel) {
  _inherits(UserMasterPanel, _FormPanel);

  var _super = _createSuper$7(UserMasterPanel);

  function UserMasterPanel() {
    _classCallCheck(this, UserMasterPanel);

    return _super.apply(this, arguments);
  }

  _createClass(UserMasterPanel, [{
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props = this.props,
          classes = _this$props.classes,
          edited = _this$props.edited,
          readOnly = _this$props.readOnly;
      var userRoles = edited && edited.roles ? edited.roles : [];
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Grid, {
        container: true,
        className: classes.item
      }, /*#__PURE__*/React.createElement(Grid, {
        item: true,
        xs: 4,
        className: classes.item
      }, /*#__PURE__*/React.createElement(TextInput, {
        module: "admin",
        required: true,
        label: "user.username",
        readOnly: Boolean(edited.id) || readOnly,
        value: edited ? edited.username : "",
        onChange: function onChange(p) {
          return _this.updateAttribute("username", p);
        }
      })), /*#__PURE__*/React.createElement(Grid, {
        item: true,
        xs: 4,
        className: classes.item
      }, /*#__PURE__*/React.createElement(PublishedComponent, {
        required: true,
        pubRef: "admin.UserTypesPicker",
        value: edited && edited.userTypes || getUserTypes(edited),
        module: "admin",
        readOnly: readOnly,
        onChange: function onChange(p) {
          return _this.updateAttribute("userTypes", p);
        }
      })), /*#__PURE__*/React.createElement(Grid, {
        item: true,
        xs: 4,
        className: classes.item
      }, /*#__PURE__*/React.createElement(PublishedComponent, {
        pubRef: "admin.UserRolesPicker",
        required: !!(edited.iUser || edited.userTypes && edited.userTypes.includes("INTERACTIVE")),
        value: userRoles || [],
        module: "admin",
        readOnly: readOnly,
        onChange: function onChange(roles) {
          return _this.updateAttributes({
            roles: roles
          });
        }
      }))), /*#__PURE__*/React.createElement(Grid, {
        container: true,
        className: classes.item
      }, /*#__PURE__*/React.createElement(Grid, {
        item: true,
        xs: 4,
        className: classes.item
      }, /*#__PURE__*/React.createElement(TextInput, {
        module: "admin",
        label: "user.lastName",
        required: true,
        readOnly: readOnly,
        value: edited && edited.lastName ? edited.lastName : "",
        onChange: function onChange(lastName) {
          return _this.updateAttributes({
            lastName: lastName
          });
        }
      })), /*#__PURE__*/React.createElement(Grid, {
        item: true,
        xs: 4,
        className: classes.item
      }, /*#__PURE__*/React.createElement(TextInput, {
        module: "admin",
        label: "user.otherNames",
        required: true,
        readOnly: readOnly,
        value: edited && edited.otherNames ? edited.otherNames : "",
        onChange: function onChange(otherNames) {
          return _this.updateAttributes({
            otherNames: otherNames
          });
        }
      })), /*#__PURE__*/React.createElement(Grid, {
        item: true,
        xs: 4,
        className: classes.item
      }, /*#__PURE__*/React.createElement(PublishedComponent, {
        pubRef: "location.HealthFacilityPicker",
        value: edited && edited.healthFacility,
        module: "admin",
        readOnly: readOnly,
        onChange: function onChange(healthFacilityId) {
          return _this.updateAttributes({
            healthFacilityId: healthFacilityId
          });
        }
      })), /*#__PURE__*/React.createElement(Grid, {
        container: true,
        className: classes.item
      }, /*#__PURE__*/React.createElement(Grid, {
        item: true,
        xs: 4,
        className: classes.item
      }, /*#__PURE__*/React.createElement(TextInput, {
        module: "admin",
        type: "email",
        label: "user.email",
        readOnly: readOnly,
        value: edited && edited.email ? edited.email : "",
        onChange: function onChange(email) {
          return _this.updateAttributes({
            email: email
          });
        }
      })), /*#__PURE__*/React.createElement(Grid, {
        item: true,
        xs: 4,
        className: classes.item
      }, /*#__PURE__*/React.createElement(TextInput, {
        module: "admin",
        type: "phone",
        label: "user.phone",
        readOnly: readOnly,
        value: edited && edited.phoneNumber ? edited.phoneNumber : "",
        onChange: function onChange(phoneNumber) {
          return _this.updateAttributes({
            phoneNumber: phoneNumber
          });
        }
      })), (edited.officer || edited.userTypes && (edited.userTypes.includes("OFFICER") || edited.userTypes.includes("CLAIM_ADMIN"))) && /*#__PURE__*/React.createElement(Grid, {
        item: true,
        xs: 4,
        className: classes.item
      }, /*#__PURE__*/React.createElement(PublishedComponent, {
        pubRef: "core.DatePicker",
        value: edited && edited.birthDate ? edited.birthDate : "",
        module: "admin",
        label: "user.dob",
        readOnly: readOnly,
        onChange: function onChange(birthDate) {
          return _this.updateAttributes({
            birthDate: birthDate
          });
        }
      }))), (edited.iUser || edited.userTypes && edited.userTypes.includes("INTERACTIVE")) && /*#__PURE__*/React.createElement(Grid, {
        container: true,
        className: classes.item
      }, /*#__PURE__*/React.createElement(Grid, {
        item: true,
        xs: 4,
        className: classes.item
      }, /*#__PURE__*/React.createElement(TextInput, {
        module: "admin",
        type: "password",
        label: "user.password",
        readOnly: readOnly,
        value: "",
        onChange: function onChange(password) {
          return _this.updateAttributes({
            password: password
          });
        }
      })), /*#__PURE__*/React.createElement(Grid, {
        item: true,
        xs: 4,
        className: classes.item
      }, /*#__PURE__*/React.createElement(PublishedComponent, {
        pubRef: "core.LanguagePicker",
        module: "admin",
        label: "user.language",
        readOnly: readOnly,
        value: edited && edited.language ? edited.language : "en",
        onChange: function onChange(language) {
          return _this.updateAttributes({
            language: language
          });
        }
      }))), (edited.iUser || edited.userTypes && edited.userTypes.includes("OFFICER")) && /*#__PURE__*/React.createElement(Grid, {
        container: true,
        className: classes.item
      }, /*#__PURE__*/React.createElement(Grid, {
        item: true,
        xs: 4,
        className: classes.item
      }, /*#__PURE__*/React.createElement(TextInput, {
        module: "admin",
        label: "user.address",
        multiline: true,
        rows: 2,
        readOnly: readOnly,
        value: edited && edited.address ? edited.address : "",
        onChange: function onChange(address) {
          return _this.updateAttributes({
            address: address
          });
        }
      })), /*#__PURE__*/React.createElement(Grid, {
        item: true,
        xs: 4,
        className: classes.item
      }, /*#__PURE__*/React.createElement(PublishedComponent, {
        pubRef: "core.DatePicker",
        value: edited && edited.worksTo ? edited.worksTo : "",
        module: "admin",
        label: "user.worksTo",
        readOnly: readOnly,
        onChange: function onChange(worksTo) {
          return _this.updateAttributes({
            worksTo: worksTo
          });
        }
      })))));
    }
  }]);

  return UserMasterPanel;
}(FormPanel);

var mapStateToProps$4 = function mapStateToProps(state) {
  return {
    rights: !!state.core && !!state.core.user && !!state.core.user.i_user ? state.core.user.i_user.rights : []
  };
};

var UserMasterPanel$1 = injectIntl(withModulesManager(withHistory(connect(mapStateToProps$4)(withTheme(withStyles(styles$3)(UserMasterPanel))))));

function ownKeys$2(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$2(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$2(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper$6(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$6(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$6() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var styles$2 = function styles(theme) {
  return {
    lockedPage: theme.page.locked
  };
};

var USER_OVERVIEW_MUTATIONS_KEY = "user.UserOverview.mutations";

var UserForm = /*#__PURE__*/function (_Component) {
  _inherits(UserForm, _Component);

  var _super = _createSuper$6(UserForm);

  function UserForm() {
    var _this;

    _classCallCheck(this, UserForm);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      lockNew: false,
      reset: 0,
      user: _this.newUser(),
      newUser: true,
      consirmedAction: null
    });

    _defineProperty(_assertThisInitialized(_this), "add", function () {
      _this.setState(function (state) {
        return {
          user: _this.newUser(),
          newUser: true,
          lockNew: false,
          reset: state.reset + 1
        };
      }, function (e) {
        _this.props.add();

        _this.forceUpdate();
      });
    });

    _defineProperty(_assertThisInitialized(_this), "reload", function () {
      var family = _this.state.family;
      var _this$props$mutation = _this.props.mutation,
          clientMutationId = _this$props$mutation.clientMutationId,
          userId = _this$props$mutation.userId;

      if (clientMutationId && !userId) {
        _this.props.fetchUserMutation(_this.props.modulesManager, clientMutationId).then(function (res) {
          var mutationLogs = parseData(res.payload.data.mutationLogs);

          if (mutationLogs && mutationLogs[0] && mutationLogs[0].users && mutationLogs[0].users[0] && mutationLogs[0].users[0].coreUser) {
            var id = parseData(res.payload.data.mutationLogs)[0].users[0].coreUser.id;

            if (id) {
              historyPush(_this.props.modulesManager, _this.props.history, "admin.userOverview", [id]);
            }
          }
        });
      } else {
        _this.props.fetchUser(_this.props.modulesManager, userId, family.clientMutationId);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "canSave", function () {
      console.log({
        userTypes: _this.state.user
      });
      return _this.state.user && _this.state.user.lastName && _this.state.user.otherNames && (!_this.state.user.userTypes.includes("INTERACTIVE") || _this.state.user.roles) && _this.state.user.username && _this.state.user.userTypes;
    });

    _defineProperty(_assertThisInitialized(_this), "save", function (user) {
      _this.setState({
        lockNew: !user.id
      }, // avoid duplicates
      function (e) {
        return _this.props.save(user);
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onEditedChanged", function (user) {
      _this.setState({
        user: user,
        newUser: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onActionToConfirm", function (title, message, confirmedAction) {
      _this.setState({
        confirmedAction: confirmedAction
      }, _this.props.coreConfirm(title, message));
    });

    return _this;
  }

  _createClass(UserForm, [{
    key: "newUser",
    value: function newUser() {
      return {};
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      document.title = formatMessageWithValues(this.props.intl, "admin.user", "UserOverview.title", {
        label: ""
      });

      if (this.props.userId) {
        this.setState(function (state, props) {
          return {
            userId: props.userId
          };
        }, function (e) {
          return _this2.props.fetchUser(_this2.props.modulesManager, _this2.props.userId);
        });
      }

      if (this.props.id) {
        this.setState({
          user: _objectSpread$2(_objectSpread$2({}, this.newUser()), {}, {
            id: this.props.id
          })
        });
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (!prevProps.fetchedUser && !!this.props.fetchedUser) {
        var user = this.props.user;
        this.setState({
          user: user,
          userId: user.id,
          lockNew: false,
          newUser: false
        });
      } else if (prevProps.userId && !this.props.userId) {
        this.setState({
          user: this.newUser(),
          newUser: true,
          lockNew: false,
          userId: null
        });
      } else if (prevProps.submittingMutation && !this.props.submittingMutation) {
        this.props.journalize(this.props.mutation);
        this.setState(function (state, props) {
          return {
            user: _objectSpread$2(_objectSpread$2({}, state.user), {}, {
              clientMutationId: props.mutation.clientMutationId
            })
          };
        });
      } else if (prevProps.confirmed !== this.props.confirmed && !!this.props.confirmed && !!this.state.confirmedAction) {
        this.state.confirmedAction();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          modulesManager = _this$props.modulesManager,
          classes = _this$props.classes,
          state = _this$props.state,
          rights = _this$props.rights,
          userId = _this$props.userId,
          fetchingUser = _this$props.fetchingUser,
          fetchedUser = _this$props.fetchedUser,
          errorUser = _this$props.errorUser,
          _this$props$overview = _this$props.overview,
          overview = _this$props$overview === void 0 ? false : _this$props$overview,
          _this$props$readOnly = _this$props.readOnly,
          readOnly = _this$props$readOnly === void 0 ? false : _this$props$readOnly,
          add = _this$props.add,
          save = _this$props.save,
          back = _this$props.back;
      var _this$state = this.state,
          user = _this$state.user,
          reset = _this$state.reset;
      if (!rights.includes(RIGHT_USERS)) return null;
      var runningMutation = !!user && !!user.clientMutationId;
      var contributedMutations = modulesManager.getContribs(USER_OVERVIEW_MUTATIONS_KEY);

      for (var i = 0; i < contributedMutations.length && !runningMutation; i += 1) {
        runningMutation = contributedMutations[i](state);
      }

      var actions = [{
        doIt: this.reload,
        icon: /*#__PURE__*/React.createElement(ReplayIcon, null),
        onlyIfDirty: !readOnly && !runningMutation
      }];
      return /*#__PURE__*/React.createElement("div", {
        className: runningMutation ? classes.lockedPage : null
      }, /*#__PURE__*/React.createElement(ProgressOrError, {
        progress: fetchingUser,
        error: errorUser
      }), (!!fetchedUser && !!user && user.id === userId || !userId) && /*#__PURE__*/React.createElement(Form, {
        module: "user",
        title: this.state.newUser ? "admin.user.UserOverview.newTitle" : "admin.user.UserOverview.title",
        edited_id: userId,
        edited: user,
        reset: reset,
        back: back,
        add: !!add && !this.state.newUser ? this.add : null,
        readOnly: readOnly || runningMutation || !!user && !!user.validityTo,
        actions: actions,
        overview: overview,
        HeadPanel: UserMasterPanel$1,
        user: user,
        onEditedChanged: this.onEditedChanged,
        canSave: this.canSave,
        save: save ? this.save : null,
        onActionToConfirm: this.onActionToConfirm
      }));
    }
  }]);

  return UserForm;
}(Component);

var mapStateToProps$3 = function mapStateToProps(state) {
  return {
    rights: !!state.core && !!state.core.user && !!state.core.user.i_user ? state.core.user.i_user.rights : [],
    fetchingUser: state.admin.fetchingUser,
    errorUser: state.admin.errorUser,
    fetchedUser: state.admin.fetchedUser,
    submittingMutation: state.admin.submittingMutation,
    mutation: state.admin.mutation,
    user: state.admin.user,
    confirmed: state.core.confirmed,
    state: state
  };
};

var mapDispatchToProps$2 = function mapDispatchToProps(dispatch) {
  return bindActionCreators({
    fetchUser: fetchUser,
    newUser: newUser,
    createUser: createUser,
    fetchUserMutation: fetchUserMutation,
    journalize: journalize,
    coreConfirm: coreConfirm
  }, dispatch);
};

var UserForm$1 = withHistory(withModulesManager(connect(mapStateToProps$3, mapDispatchToProps$2)(injectIntl(withTheme(withStyles(styles$2)(UserForm))))));

function _createSuper$5(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$5(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$5() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var styles$1 = function styles(theme) {
  return {
    page: theme.page
  };
};

var UserPage = /*#__PURE__*/function (_Component) {
  _inherits(UserPage, _Component);

  var _super = _createSuper$5(UserPage);

  function UserPage() {
    var _this;

    _classCallCheck(this, UserPage);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "add", function () {
      historyPush(_this.props.modulesManager, _this.props.history, "admin.userNew");
    });

    _defineProperty(_assertThisInitialized(_this), "save", function (user) {
      if (!user.id) {
        _this.props.createUser(_this.props.modulesManager, user, formatMessageWithValues(_this.props.intl, "admin.user", "createUser.mutationLabel"));
      } else {
        _this.props.updateUser(_this.props.modulesManager, user, formatMessageWithValues(_this.props.intl, "admin.user", "updateUser.mutationLabel"));
      }
    });

    return _this;
  }

  _createClass(UserPage, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          classes = _this$props.classes,
          rights = _this$props.rights,
          userId = _this$props.userId,
          overview = _this$props.overview,
          modulesManager = _this$props.modulesManager,
          history = _this$props.history;
      if (!rights.includes(RIGHT_USER_EDIT)) return null;
      return /*#__PURE__*/React.createElement("div", {
        className: classes.page
      }, /*#__PURE__*/React.createElement(UserForm$1, {
        overview: overview,
        userId: userId,
        back: function back(e) {
          return historyPush(modulesManager, history, "admin.users");
        },
        add: rights.includes(RIGHT_USER_ADD) ? this.add : null,
        save: rights.includes(RIGHT_USER_EDIT) ? this.save : null
      }));
    }
  }]);

  return UserPage;
}(Component);

var mapStateToProps$2 = function mapStateToProps(state, props) {
  return {
    rights: !!state.core && !!state.core.user && !!state.core.user.i_user ? state.core.user.i_user.rights : [],
    userId: props.match.params.user_id
  };
};

var mapDispatchToProps$1 = function mapDispatchToProps(dispatch) {
  return bindActionCreators({
    createUser: createUser,
    updateUser: updateUser
  }, dispatch);
};

var UserPage$1 = withHistory(withModulesManager(connect(mapStateToProps$2, mapDispatchToProps$1)(injectIntl(withTheme(withStyles(styles$1)(UserPage))))));

function _createSuper$4(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$4(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$4() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var UserOverviewPage = /*#__PURE__*/function (_Component) {
  _inherits(UserOverviewPage, _Component);

  var _super = _createSuper$4(UserOverviewPage);

  function UserOverviewPage() {
    _classCallCheck(this, UserOverviewPage);

    return _super.apply(this, arguments);
  }

  _createClass(UserOverviewPage, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          history = _this$props.history,
          modulesManager = _this$props.modulesManager,
          userId = _this$props.userId;
      var actions = [{
        doIt: function doIt(e) {
          return historyPush(modulesManager, history, "admin.userOverview", [userId]);
        },
        icon: /*#__PURE__*/React.createElement(Edit, null),
        onlyIfDirty: false
      }];
      return /*#__PURE__*/React.createElement(UserPage$1, _extends({}, this.props, {
        readOnly: true,
        overview: true,
        actions: actions
      }));
    }
  }]);

  return UserOverviewPage;
}(Component);

var mapStateToProps$1 = function mapStateToProps(state, props) {
  return {
    userId: props.match.params.user_id
  };
};

var UserOverviewPage$1 = withHistory(withModulesManager(connect(mapStateToProps$1)(UserOverviewPage)));

function _createSuper$3(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$3(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$3() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var EnrollmentOfficersPage = /*#__PURE__*/function (_Component) {
  _inherits(EnrollmentOfficersPage, _Component);

  var _super = _createSuper$3(EnrollmentOfficersPage);

  function EnrollmentOfficersPage() {
    _classCallCheck(this, EnrollmentOfficersPage);

    return _super.apply(this, arguments);
  }

  _createClass(EnrollmentOfficersPage, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(ProxyPage, {
        url: "/FindOfficer.aspx"
      });
    }
  }]);

  return EnrollmentOfficersPage;
}(Component);

function _createSuper$2(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$2(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$2() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var ClaimAdministratorsPage = /*#__PURE__*/function (_Component) {
  _inherits(ClaimAdministratorsPage, _Component);

  var _super = _createSuper$2(ClaimAdministratorsPage);

  function ClaimAdministratorsPage() {
    _classCallCheck(this, ClaimAdministratorsPage);

    return _super.apply(this, arguments);
  }

  _createClass(ClaimAdministratorsPage, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(ProxyPage, {
        url: "/FindClaimAdministrator.aspx"
      });
    }
  }]);

  return ClaimAdministratorsPage;
}(Component);

function _createSuper$1(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$1(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$1() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var PayersPage = /*#__PURE__*/function (_Component) {
  _inherits(PayersPage, _Component);

  var _super = _createSuper$1(PayersPage);

  function PayersPage() {
    _classCallCheck(this, PayersPage);

    return _super.apply(this, arguments);
  }

  _createClass(PayersPage, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(ProxyPage, {
        url: "/FindPayer.aspx"
      });
    }
  }]);

  return PayersPage;
}(Component);

var messagesEn = {
	"admin.UserPicker.label": "User",
	"admin.UserPicker.null": "Any",
	"admin.mainMenu": "Administration",
	"admin.menu.claimAdministrators": "Claim Administrators",
	"admin.menu.enrollmentOfficers": "Enrollment Officers",
	"admin.menu.healthFacilities": "Health Facilities",
	"admin.menu.locations": "Locations",
	"admin.menu.medicalItems": "Medical Items",
	"admin.menu.medicalItemsPrices": "Medical Items Price List",
	"admin.menu.medicalServices": "Medical Services",
	"admin.menu.medicalServicesPrices": "Medical Services Price List",
	"admin.menu.payers": "Payers",
	"admin.menu.products": "Products",
	"admin.menu.users": "Users",
	"admin.menu.usersProfiles": "Users Profiles",
	"admin.showHistory": "Show historical values",
	"admin.user.CreateUser.mutationLabel": "Create user",
	"admin.user.UserOverview.newTitle": "New User",
	"admin.user.UserOverview.title": "User Details",
	"admin.user.address": "Address",
	"admin.user.addNewUser.tooltip": "Add new user",
	"admin.user.addNewUserTooltip": "Add new user",
	"admin.user.createUser.mutationLabel": "Create user",
	"admin.user.deleteDialog.message": "Are you sure you want to delete this user?",
	"admin.user.deleteDialog.title": "Delete user",
	"admin.user.deleteDialog.yes.button": "Yes",
	"admin.user.deleteUser.tooltip": "Delete user",
	"admin.user.deleteUserDialog.message": "Are you sure you want to delete this user?",
	"admin.user.dob": "Birth date",
	"admin.user.dobFrom": "Birth date from",
	"admin.user.dobTo": "Birth date to",
	"admin.user.email": "Email",
	"admin.user.lastName": "Last name",
	"admin.user.language": "Language",
	"admin.user.openNewTab": "Open in new tab",
	"admin.user.otherNames": "Other names",
	"admin.user.password": "Password",
	"admin.user.phone": "Phone",
	"admin.user.updateUser.mutationLabel": "Update user",
	"admin.user.userRoles": "User role(s)",
	"admin.user.userRoles.noOptions": "No user role found",
	"admin.user.userSummaries": "{count} user(s) found",
	"admin.user.userTypes": "User type(s)",
	"admin.user.userTypes.CLAIM_ADMIN": "Claim admin",
	"admin.user.userTypes.INTERACTIVE": "Interactive",
	"admin.user.userTypes.OFFICER": "Officer",
	"admin.user.userTypes.noOptions": "No user type found",
	"admin.user.userTypes.none": " ",
	"admin.user.userTypes.null": "Any",
	"admin.user.username": "User name",
	"admin.user.worksTo": "Works to"
};

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var styles = function styles(theme) {
  return {
    label: {
      color: theme.palette.primary.main
    }
  };
};

var UserPicker = /*#__PURE__*/function (_Component) {
  _inherits(UserPicker, _Component);

  var _super = _createSuper(UserPicker);

  function UserPicker(props) {
    var _this;

    _classCallCheck(this, UserPicker);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "formatSuggestion", function (p) {
      return !p ? "" : "".concat(p.username || "");
    });

    _defineProperty(_assertThisInitialized(_this), "onSuggestionSelected", function (v) {
      return _this.props.onChange(v, _this.formatSuggestion(v));
    });

    _defineProperty(_assertThisInitialized(_this), "getSuggestions", function (str) {
      return !!str && str.length >= _this.props.modulesManager.getConf("fe-admin", "usersMinCharLookup", 2) && _this.props.fetchUsers(_this.props.modulesManager, _this.props.userHealthFacilityFullPath, str, _this.props.fetchedUsers);
    });

    _defineProperty(_assertThisInitialized(_this), "debouncedGetSuggestion", _.debounce(_this.getSuggestions, _this.props.modulesManager.getConf("fe-admin", "debounceTime", 800)));

    _this.selectThreshold = props.modulesManager.getConf("fe-admin", "UserPicker.selectThreshold", 10);
    return _this;
  }

  _createClass(UserPicker, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          intl = _this$props.intl,
          value = _this$props.value,
          reset = _this$props.reset,
          _this$props$readOnly = _this$props.readOnly,
          readOnly = _this$props$readOnly === void 0 ? false : _this$props$readOnly,
          _this$props$required = _this$props.required,
          required = _this$props$required === void 0 ? false : _this$props$required,
          users = _this$props.users,
          fetchingUsers = _this$props.fetchingUsers,
          errorUsers = _this$props.errorUsers,
          _this$props$withNull = _this$props.withNull,
          withNull = _this$props$withNull === void 0 ? false : _this$props$withNull,
          _this$props$nullLabel = _this$props.nullLabel,
          nullLabel = _this$props$nullLabel === void 0 ? null : _this$props$nullLabel,
          _this$props$withLabel = _this$props.withLabel,
          withLabel = _this$props$withLabel === void 0 ? true : _this$props$withLabel,
          label = _this$props.label;
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(ProgressOrError, {
        progress: fetchingUsers,
        error: errorUsers
      }), !fetchingUsers && !errorUsers && /*#__PURE__*/React.createElement(AutoSuggestion, {
        module: "admin",
        items: users,
        label: !!withLabel && (label || formatMessage(intl, "admin", "UserPicker.label")),
        getSuggestions: this.debouncedGetSuggestion,
        renderSuggestion: function renderSuggestion(a) {
          return /*#__PURE__*/React.createElement("span", null, _this2.formatSuggestion(a));
        },
        getSuggestionValue: this.formatSuggestion,
        onSuggestionSelected: this.onSuggestionSelected,
        value: value,
        reset: reset,
        readOnly: readOnly,
        required: required,
        selectThreshold: this.selectThreshold,
        withNull: withNull,
        nullLabel: nullLabel || formatMessage(intl, "admin", "UserPicker.null")
      }));
    }
  }]);

  return UserPicker;
}(Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    userHealthFacilityFullPath: state.loc ? state.loc.userHealthFacilityFullPath : null,
    users: state.admin.users,
    fetchedUsers: state.admin.fetchedUsers
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return bindActionCreators({
    fetchUsers: fetchUsers
  }, dispatch);
};

var UserPicker$1 = withModulesManager(connect(mapStateToProps, mapDispatchToProps)(injectIntl(withTheme(withStyles(styles)(UserPicker)))));

var UserRolesPicker = function UserRolesPicker(_ref) {
  var readOnly = _ref.readOnly,
      modulesManager = _ref.modulesManager,
      value = _ref.value,
      _onChange = _ref.onChange,
      required = _ref.required;
  var intl = useIntl();
  var roles = useSelector(function (state) {
    return state.admin.userRoles;
  });
  var userHealthFacilityFullPath = useSelector(function (state) {
    return state.loc ? state.loc.userHealthFacilityFullPath : null;
  });
  var fetchingUserRoles = useSelector(function (state) {
    return state.admin.fetchingUserRoles;
  });
  var dispatch = useDispatch();
  useEffect(function () {
    dispatch(fetchUserRoles(modulesManager, userHealthFacilityFullPath));
  }, []);
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(ProgressOrError, {
    progress: fetchingUserRoles
  }), !fetchingUserRoles && /*#__PURE__*/React.createElement(Autocomplete, {
    loading: fetchingUserRoles,
    multiple: true,
    disabled: readOnly,
    noOptionsText: formatMessage(intl, "admin.user", "userRoles.noOptions"),
    id: "user-role-select",
    options: roles,
    getOptionLabel: function getOptionLabel(option) {
      return option.name;
    },
    getOptionSelected: function getOptionSelected(option, val) {
      return option.id === val.id;
    },
    onChange: function onChange(e, userRoles) {
      return _onChange(userRoles);
    },
    renderInput: function renderInput(params) {
      return /*#__PURE__*/React.createElement(TextField, _extends({}, params, {
        variant: "standard",
        label: "".concat(formatMessage(intl, "admin.user", "userRoles")).concat(required ? "*" : ""),
        placeholder: ""
      }));
    },
    value: value
  }));
};

var UserRolesPicker$1 = withModulesManager(UserRolesPicker);

var UserTypesPicker = function UserTypesPicker(props) {
  var intl = useIntl();
  var rights = useSelector(function (state) {
    return !!state.core && !!state.core.user && !!state.core.user.i_user ? state.core.user.i_user.rights : [];
  });
  var options = USER_TYPES(rights).map(function (ut) {
    return {
      id: ut,
      label: formatMessage(intl, "admin.user", "userTypes.".concat(ut))
    };
  });
  var value = [];

  if (props.value) {
    props.value.forEach(function (v) {
      var fullValue = options.find(function (o) {
        return o.id === v;
      });

      if (fullValue) {
        value.push(fullValue);
      }
    });
  }

  return /*#__PURE__*/React.createElement(Autocomplete, {
    multiple: true,
    noOptionsText: formatMessage(intl, "admin.user", "userTypes.noOptions"),
    disabled: props.readOnly,
    id: "user-types-select",
    options: options,
    getOptionLabel: function getOptionLabel(option) {
      return option.label;
    },
    onChange: function onChange(e, userTypes) {
      return props.onChange(userTypes.map(function (ut) {
        return ut.id;
      }));
    },
    renderInput: function renderInput(params) {
      return /*#__PURE__*/React.createElement(TextField, _extends({}, params, {
        variant: "standard",
        label: "".concat(formatMessage(intl, "admin.user", "userTypes")).concat(props.required ? "*" : ""),
        placeholder: ""
      }));
    },
    value: value
  });
};

function ownKeys$1(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$1(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$1(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$1(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    fetchingUsers: false,
    fetchingUsersSummaries: false,
    fetchingUser: false,
    fetchedUsers: null,
    fetchedUsersSummaries: null,
    fetchedUser: false,
    errorUsers: null,
    errorUsersSummaries: null,
    errorUser: null,
    users: null,
    usersSummaries: null,
    user: null,
    usersPageInfo: {
      totalCount: 0
    },
    submittingMutation: false,
    mutation: {},
    fetchingUserRoles: false,
    fetchedUserRoles: null,
    errorRoles: null,
    userRoles: []
  };
  var action = arguments.length > 1 ? arguments[1] : undefined;

  switch (action.type) {
    case "ADMIN_USERS_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUsers: true,
        fetchedUsers: null,
        users: null,
        errorUsers: null
      });

    case "ADMIN_USERS_RESP":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUsers: false,
        fetchedUsers: action.meta,
        users: parseData(action.payload.data.users).map(function (user) {
          return _objectSpread$1(_objectSpread$1({}, user), {}, {
            userTypes: getUserTypes(user)
          });
        }),
        errorUsers: formatGraphQLError(action.payload)
      });

    case "ADMIN_USERS_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUsers: null,
        errorUsers: formatServerError(action.payload)
      });

    case "ADMIN_USER_ROLES_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUserRoles: true,
        fetchedUserRoles: null,
        userRoles: [],
        errorUsers: null
      });

    case "ADMIN_USER_ROLES_RESP":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUserRoles: false,
        fetchedUserRoles: action.meta,
        userRoles: parseData(action.payload.data.role),
        errorRoles: formatGraphQLError(action.payload)
      });

    case "ADMIN_USER_ROLES_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUserRoles: null,
        errorRoles: formatServerError(action.payload)
      });

    case "ADMIN_USERS_SUMMARIES_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUsersSummaries: true,
        fetchedUsersSummaries: null,
        usersSummaries: null,
        errorUsersSummaries: null
      });

    case "ADMIN_USERS_SUMMARIES_RESP":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUsersSummaries: false,
        fetchedUsersSummaries: action.meta,
        usersSummaries: parseData(action.payload.data.users),
        usersPageInfo: pageInfo(action.payload.data.users),
        errorUsersSummaries: formatGraphQLError(action.payload)
      });

    case "ADMIN_USERS_SUMMARIES_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUsersSummaries: null,
        errorUsersSummaries: formatServerError(action.payload)
      });

    case "ADMIN_USER_OVERVIEW_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUser: true,
        fetchedUser: false,
        contribution: null,
        errorUser: null
      });

    case "ADMIN_USER_OVERVIEW_RESP":
      var users = parseData(action.payload.data.users);
      var user = null;

      if (!!users && users.length > 0) {
        var _users = _slicedToArray(users, 1);

        user = _users[0];
        user = _objectSpread$1(_objectSpread$1({}, mapQueriesUserToMutation(user)), {}, {
          userTypes: getUserTypes(user)
        });
      }

      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUser: false,
        fetchedUser: true,
        user: user,
        errorUser: formatGraphQLError(action.payload)
      });

    case "ADMIN_USER_OVERVIEW_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchedUser: false,
        errorUser: formatServerError(action.payload)
      });

    case "ADMIN_USER_NEW":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        usersPageInfo: {
          totalCount: 0
        },
        user: null
      });

    case "ADMIN_USER_MUTATION_REQ":
      return dispatchMutationReq(state, action);

    case "ADMIN_USER_MUTATION_ERR":
      return dispatchMutationErr(state, action);

    case "ADMIN_USER_UPDATE_RESP":
      return dispatchMutationResp(state, "updateUser", action);

    case "ADMIN_USER_DELETE_RESP":
      return dispatchMutationResp(state, "deleteUser", action);

    case "ADMIN_USER_CREATE_RESP":
      return dispatchMutationResp(state, "createUser", action);

    default:
      return state;
  }
}

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var ROUTE_ADMIN_USERS = "admin/users";
var ROUTE_ADMIN_USER_OVERVIEW = "admin/users/overiew";
var ROUTE_ADMIN_USER_NEW = "admin/users/new";
var DEFAULT_CONFIG = {
  translations: [{
    key: "en",
    messages: messagesEn
  }],
  reducers: [{
    key: "admin",
    reducer: reducer
  }],
  "core.Router": [{
    path: "admin/products",
    component: ProductsPage
  }, {
    path: "admin/medicalServicesPriceList",
    component: MedicalServicesPriceListPage
  }, {
    path: "admin/medicalItemsPriceList",
    component: MedicalItemsPriceListPage
  }, {
    path: "admin/medicalServices",
    component: MedicalServicesPage
  }, {
    path: "admin/medilcalItems",
    component: MedicalItemsPage
  }, {
    path: ROUTE_ADMIN_USERS,
    component: UsersPage$1
  }, {
    path: ROUTE_ADMIN_USER_NEW,
    component: UserPage$1
  }, {
    path: "".concat(ROUTE_ADMIN_USER_OVERVIEW, "/:user_id"),
    component: UserOverviewPage$1
  }, {
    path: "admin/enrollmentOfficers",
    component: EnrollmentOfficersPage
  }, {
    path: "admin/claimAdministrators",
    component: ClaimAdministratorsPage
  }, {
    path: "admin/payers",
    component: PayersPage
  }],
  "core.MainMenu": [AdminMainMenu$1],
  refs: [{
    key: "admin.UserPicker",
    ref: UserPicker$1
  }, {
    key: "admin.UserRolesPicker",
    ref: UserRolesPicker$1
  }, {
    key: "admin.UserTypesPicker",
    ref: UserTypesPicker
  }, {
    key: "admin.UserPicker.projection",
    ref: ["id", "username", "iUser{id}"]
  }, {
    key: "admin.UserRolesPicker.projection",
    ref: ["id", "name"]
  }, {
    key: "admin.users",
    ref: ROUTE_ADMIN_USERS
  }, {
    key: "admin.userOverview",
    ref: ROUTE_ADMIN_USER_OVERVIEW
  }, {
    key: "admin.userNew",
    ref: ROUTE_ADMIN_USER_NEW
  }]
};
var AdminModule = function AdminModule(cfg) {
  return _objectSpread(_objectSpread({}, DEFAULT_CONFIG), cfg);
};

export { AdminModule };
//# sourceMappingURL=index.es.js.map
